<?php

/*
Plugin Name: Easyteasers
Plugin URI: http://www.stadtkreation.de/wordpress.php?lang=en
Description: Simple plugin for dynamically adding image and text teasers for posts and pages. Use [easyteasers] for showing teasers for all child pages or [easyteasers type="posttype-slug" count="number of posts to show" ids="ids of posts to show, comma-separated"].
Version: 0.1.10
Author: STADTKREATION
Text Domain: easyteasers
Domain Path: /languages/
Author URI: http://www.stadtkreation.de/portrait.php?lang=en
*/

// plugin description for translation
__('Simple plugin for dynamically adding image and text teasers for posts and pages. Use [easyteasers] for showing teasers for all child pages or [easyteasers type="posttype-slug" count="number of posts to show" ids="ids of posts to show, comma-separated" textonly="true/false"].','easyteasers');

// plugin textdomain definition
function easyteasers_textdomain() {
	$plugin_dir = basename(dirname(__FILE__));
	load_plugin_textdomain( 'easyteasers', false, $plugin_dir.'/languages/' );
}
add_action('plugins_loaded', 'easyteasers_textdomain');

// load easytaesers header scripts and styles
function easytaesers_enqueue() {
	wp_enqueue_style('easyteasers-style',plugins_url('', __FILE__).'/easyteasers.css');
	wp_enqueue_script('jquery');
	wp_enqueue_script('easyteasers-script',plugins_url('', __FILE__).'/easyteasers.js',array(),'20150924',true);
}
add_action('wp_enqueue_scripts', 'easytaesers_enqueue');

// shortcode [easyteasers]
function output_easyteasers($atts) {
	global $post;
	$a = shortcode_atts( array(
        'type' => 'page',
		'parent' => '',
        'count' => '',
		'ids' => '',
		'textonly' => false
    ), $atts );
	$query_string =  array(
		'posts_per_page' => -1,
		'post_type' => $a['type'],
		'post_count' => 1,
		'orderby' => 'menu_order',
		'order' => 'ASC'
	);
	if($a['count']) $query_string['posts_per_page']=$a['count'];
	if($a['ids']) $query_string['post__in']=explode(',',$a['ids']);
	if(!$a['parent'] && !$a['show'] && !$a['ids']) $query_string['post_parent']=$post->ID;
	$second_query = new WP_Query($query_string);
	$output = '';
	$output .= '<div class="easyteasers'.($a['textonly'] ? ' textonly' : '').'">';
	while($second_query->have_posts()) {
		$second_query->the_post();
		global $post;
		if(!$a['textonly']) {
			$url = '';
			$thumb = wp_get_attachment_image_src( get_post_thumbnail_id($post->ID), 'large' );
			$theme_topic_settings = get_option($theme->textdomain.'-topic-settings');
			if($thumb[0]) $url = $thumb['0'];
		}
		$output .= '<div class="easyteaser"'.($url ? ' style="background-image:url('.$url.')"' : '').'>';
		$output .= '<h3 class="easyteaser-title"><a href="'.get_permalink().'" rel="bookmark">'.get_the_title().'</a></h3>';
		$output .= '<div class="easyteaser-text'.(!$a['showtext'] ? ' noshow' : '').'">';
		if($a['showtext']) $output .= '<p>'.wp_trim_words(get_the_content(),15).'<br />';
		$more_link_text = sprintf(	__( 'Continue reading %s <span class="meta-nav">&rarr;</span>', 'easyteasers' ),the_title( '<span class="screen-reader-text">', '</span>', false ));
		$output .= '</div>';
		$output .= '<a title="'.strip_tags($more_link_text).'" class="more-link" href="'.get_permalink($post->ID).'">'.$more_link_text .'</a>';
		ob_start();
		edit_post_link( __( 'Edit', 'easyteasers' ), '<p class="edit-link-block"><span class="edit-link">', '</span></p>' );
		$output .= ob_get_contents();
		$output .= '</div>';
		ob_end_clean();
		wp_reset_postdata();
	}
	$output .= '</div>';
	return $output;
}
add_shortcode('easyteasers','output_easyteasers');
